//Dfinitions
typedef unsigned char *TABLEAU;

typedef struct
{        //Structure d'un sprite
	int type;                        //Type (identifieur) du sprite
	union
	{
		struct
		{
			int virgule_x;
			int x;
		};
		s64 valeur_x;
	};
	union
	{
		struct
		{
			int virgule_y;
			int y;
		};
		s64 valeur_y;
	};
	int dir;                        //Direction du sprite
	int cpt;                        //Compteur

	//        int etat;                                           //Etat spcial
	void (*fctEtat) ();
	int vx;                                //Vitesse du sprite
	int vy;                                //Sa gravit
	int lastX, lastY;        //Pour la gestion de la camra
	int saut;                        //Saut effectu
	int hauteur;                //Sa hauteur
	int largeur;                //Sa largeur
	int angle, vangle;        //Angle et angle affich (vangle)
	int A;
	int vitesseY;
	unsigned char croche, enboule, colBas;        //, colDroite, colGauche;
	unsigned char colHaut, colDroite, colGauche, pousseMurGauche, pousseMurDroite, col2D, colBasObj;
	signed char colSol;
	unsigned short virgule;
	short no_sprite;
	unsigned char premAppui, decole, crochePF;
	unsigned short clignote, invincible, tempsEau;
	u32 score;
	u16 bagues;
	u8 interdit_saut, sous_leau;
	u32 controle;
	u8 enbouleobligatoire;
	u8 prio;

	//        unsigned char enboulesauv;
	u16 pas_angle;        //0x1000/0x0000
} SONIC;

typedef struct
{        //Structure d'un perso
	unsigned short type;                //Type (identifieur) du sprite
	unsigned short x;                        //Position x (absolue)
	unsigned short y;                        //Position y (absolue)
	short virguleX, virguleY;        //Virgule fixe
	unsigned short cpt;                        //Compteur
	unsigned short etat;                //Etat spcial
	unsigned short depX, depY;        //Positions de dpart
	short vx;                //Vitesse du sprite
	short vy;                //Sa gravit
	short angle;        //Son angle. Utilisation gnrale.
	unsigned short hauteur;                        //Sa hauteur
	unsigned short largeur;                        //Sa largeur
	unsigned short (*fHandler) ();        //Handler du personnage en question
	signed char dir;        //Direction
	unsigned short instructions;        //Instructions pour le handler standard. Cela peut lui demander par exemple de signaler s'il y a une collision avec le personnage ou le dcor, etc. ou de dsactiver ces fonctionnalits dans le cas d'objets statiques par exemple, car cela ne sert  rien  part gaspiller du CPU... Le plus utile est notamment si on a besoin de placer le personnage sur le dcor en standard, (c'est trs compliqu  faire  chaque fois) ce qui est impossible si le personnage se trouve en dehors de l'cran -> dans ce cas-l, on quitte immdiatement le handler, sans calculs inutiles.
	unsigned short savX, savY;
	unsigned char mort, scroched;
	u16 noObjet;
	u32 donnees[16];
} PERSO;

typedef struct
{
	u16 tile;                //Tile concerne par l'animation
	u16 animbase;        //Base des nouvelles tiles  copier
	u16 timing;                //Timing (lenteur) entre deux animations
	u16 etapes;                //Nombre d'tapes par an
} ANIMATION;

typedef struct
{        //Infos sur l'cran
	TABLEAU Tampon; //"Backbuffer" de l'cran
	int scrlX;                //Scrolling x (toujours modulo 8)
	int scrlY;                //Scrolling y (toujours modulo 8)
} ECRAN;

//A utiliser sur le champ "donnees" des persos. Ces structures peuvent faire jusqu' 32 octets
typedef struct
{
	//Taille: 16 octets
	u32 param1, param2;
	s16 param3, param4;
	u16 param5, param6;
} DONNEES_STD;

enum etats { ETAT_NORMAL = 0, ETAT_TOUCHE, ETAT_BUMPER, ETAT_MORT};

//Constantes
#define LIMITE_PERSOS        (512 + 64)

enum instructions
{
	INSTR_COLLISION_DECOR        = 0x0001,        //Demande de placer le personnage sur le dcor en utilisant les mthodes standard (comme Sonic)
	INSTR_SEULEMENT_ECRAN        = 0x0002,        //Ne fait rien s'il est hors de l'cran
	INSTR_PAS_EFFACER            = 0x0004,        //Ne pas effacer le perso s'il dpasse des limites de l'cran
	INSTR_HORS_MAP               = 0x0008,        //N'est pas dans la map, donc les coordonnes depX et depY ne sont pas associes  un bloc de map
};
enum messages
{
	MSG_COLLISION_SONIC          = 0x0001,        //Message envoy en rponse  INSTR_COLLISION_SONIC -> le personnage va crever. On lui laisse une dernire chance, peut-tre qu'il a plusieurs points de vie ;)
	MSG_AFFICHER                 = 0x0002,        //Message envoy s'il faut afficher le personnage
};

enum controles
{
	CNT_TOUCHES                  = 0x00000001,
	CNT_COLLISIONS               = 0x00000002,
	CNT_SCROLLING                = 0x00000004,
	CNT_PHYSIQUE                 = 0x00000008,
	CNT_TOUS                     = 0xffffffff
};

//Variables
extern u32 posX, posY;
extern PERSO persos[LIMITE_PERSOS + 2] EWRAM_DATA;
extern int skip, idfct;
extern void *hnest;

//#define SKIP(x)     (x<<skip)

//#define SKIP_ON     (skip)
#define SKIP(x)                          (x)
#define SKIP_ON                          0

#define LitControle(s, cnt)              ((s)->controle & (cnt))
#define ActiveControle(s, cnt)           ((s)->controle |= (cnt))
#define DesactiveControle(s, cnt)        ((s)->controle &= ~(cnt))

enum types_collisions
{
	TC_GAUCHE  = 1,
	TC_DROITE  = 2,
	TC_HAUT    = 4,
	TC_BAS     = 8,
	TC_TOUS    = 15,
	TC_MOUV    = 32,
	TC_ANORMAL = 64
};

#define PARAM(perso)        ((DONNEES_STD*)(perso)->donnees)
