#include "../commun.h"
#include "sdkConstants.h"

static const unsigned short linescroll_script_goldenhill[] =
{
	0,
	128,
	136,
	140,
	144,
	156,
	152,
	172,
	160,
	208,
	184,
	224,
	208,
	256,

	0x2000,
	0
};

static ANIMATION GoldenHill_anims[] = {{0, 0, 0, 0}};

static void GoldenHill_rotationPalette(unsigned short *palette, unsigned short *values, int len)
{
	int i, j;
	j = palette[values[0]];
	for (i = 0; i < len - 1; i++)
		palette[values[i]] = palette[values[i + 1]];
	palette[values[len - 1]] = j;
}

static void GoldenHill_typesSpeciaux(SONIC *s, u32 i)
{

	/*    if (i==0x1FD)
	goto _1fe;
	//FIN RAJOUT
	if (s->croche)          {
	if (i==0x1FE)        {
	_1fe:
	if (s->vx>0)
	plan=1;
	else
	plan=0;
	}
	}
	if (i==0x1FF)        {
	if (s->vx>0)
	plan=0;
	else
	plan=1;
	}
	if (i==0x1FC)        {
	if (s->vy>0)
	plan=0;
	else
	plan=1;
	}
	if (i==0x1FB)        {
	if (s->vy>0)
	plan=1;
	else
	plan=0;
	}
	if (i==0x1FA)       {
	if (s->croche)      {
	if (s->vx>0)
	plan=2;
	else
	plan=1;
	}
	}
	if (i==0x1F9)       {
	if (!s->croche)     {
	if (s->vy>0 && plan==2)
	plan=0;
	}
	}
	if (i==0x1F8)       {
	if (s->croche)      {
	if (s->vx>0 && plan==2)
	plan=0;
	else if (s->vx<0)       {
	plan=1;
	}
	}
	}
	if (i==0x1F7)
	plan=1;
	if (i==0x1F6)       {
	if (s->vx>=0)
	s->prio=3;
	else
	s->prio=2;
	}
	if (i==0x1F5)       {
	if (s->vx<0)
	s->prio=3;
	else
	s->prio=2;
	}
	if (i==0x1F4)
	plan=0;
	if (i==0x1F3)        {
	if (s->vx>0)
	plan=0;
	else
	plan=1;
	}*/
}

//Copie les palettes standard (objets)
static void PalStandard()
{
}

//La palette doit tre modifie!
static void GoldenHillPalette()
{
	ChargePalette(patterns_nv1_palette, nPalBG(0), 64);
	ChargePalette(BG_GoldenHill_palette, nPalBG(8), 64);
	PalStandard();
}

/*
	GOLDEN HILL
*/
static const char goldenhill_incline[][16] =
{
	{ 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16 },
	{ 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 2 },
	{ 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 6, 6, 7, 7, 8 },
	{ 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 16 },
	{ 16, 15, 15, 14, 14, 13, 13, 12, 12, 11, 11, 10, 10, 9, 9, 8 },
	{ 8, 7, 7, 6, 6, 5, 5, 4, 4, 4, 3, 3, 3, 2, 2, 2 },
	{ 2, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8 },
	{ 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 12, 13, 13, 13, 13, 14 },
	{ 14, 14, 14, 14, 14, 14, 14, 15, 15, 15, 15, 15, 15, 15, 15, 15 },
	{ 15, 15, 15, 15, 15, 15, 15, 15, 15, 14, 14, 14, 14, 14, 14, 14 },
	{ 14, 13, 13, 13, 13, 12, 12, 12, 11, 11, 11, 10, 10, 9, 9, 8 },
	{ 8, 7, 7, 6, 6, 5, 5, 4, 4, 3, 3, 2, 2, 1, 1, 0 },
	{ 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3 },
	{ 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4 },
	{ 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 3 },
	{ 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 },
	{ 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1 },
	{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2 },
	{ 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4 },
	{ 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4 },
	{ 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3 },
	{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1 },
	{ 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 5 },
	{ 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 11, 12, 12, 13, 14, 15 },
	{ 15, 14, 13, 12, 12, 11, 10, 9, 9, 8, 8, 7, 7, 6, 6, 5 },
	{ 5, 4, 4, 4, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 1, 1 },
	{ 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 1, 2, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 },
	{ 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 2, 1 },
	{ 1, 2, 2, 3, 4, 5, 6, 7, 8, 9, 9, 10, 10, 11, 11, 12 },
	{ 12, 12, 13, 13, 13, 13, 14, 14, 14, 14, 14, 15, 15, 15, 15, 15 },
	{ 15, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16 },
	{ 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 15 },
	{ 15, 15, 15, 15, 15, 14, 14, 14, 14, 14, 13, 13, 13, 13, 12, 12 },
	{ 12, 11, 11, 10, 10, 9, 9, 8, 7, 6, 5, 4, 3, 2, 2, 1 },
	{ 0, 8, 15, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16 },
	{ 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 15, 8, 0 },
	{ 0, 0, 0, 4, 8, 12, 15, 16, 16, 16, 16, 16, 16, 16, 16, 16 },
	{ 16, 16, 16, 16, 16, 16, 16, 16, 16, 15, 12, 8, 4, 0, 0, 0 },
	{ 0, 0, 0, 0, 0, 0, 0, 2, 5, 7, 9, 11, 13, 14, 16, 16 },
	{ 16, 16, 14, 13, 11, 9, 7, 5, 2, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2 },
	{ 3, 5, 6, 8, 9, 10, 12, 13, 14, 15, 16, 16, 16, 16, 16, 16 },
	{ 16, 16, 16, 16, 16, 16, 15, 14, 13, 12, 10, 9, 8, 6, 5, 3 },
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 3, 4, 5 },
	{ 6, 7, 8, 9, 10, 10, 11, 12, 13, 13, 14, 15, 15, 16, 16, 16 },
	{ 16, 16, 16, 15, 15, 14, 13, 13, 12, 11, 10, 10, 9, 8, 7, 6 },
	{ 5, 4, 3, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1 },
	{ 2, 2, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 8, 9, 9 },
	{ 9, 10, 10, 10, 11, 11, 11, 11, 12, 12, 12, 12, 13, 13, 13, 13 },
	{ 13, 14, 14, 14, 14, 14, 14, 14, 15, 15, 15, 15, 15, 15, 15, 15 },
	{ 15, 15, 15, 15, 15, 15, 15, 15, 14, 14, 14, 14, 14, 14, 14, 13 },
	{ 13, 13, 13, 13, 12, 12, 12, 12, 11, 11, 11, 11, 10, 10, 10, 9 },
	{ 9, 9, 8, 8, 8, 7, 7, 6, 6, 5, 5, 4, 4, 3, 2, 2 },
	{ 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 0, 0, 0 },
};

static const char goldenhill_inclineH[][16] =
{
	{ 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 15, 15 },
	{ 14, 14, 13, 12, 12, 11, 11, 10, 10, 9, 9, 8, 8, 8, 7, 7 },
	{ 7, 6, 6, 6, 5, 5, 5, 5, 4, 4, 4, 4, 3, 3, 3, 3 },
	{ 3, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1 },
	{ 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3 },
	{ 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 6, 6, 6, 7 },
	{ 7, 7, 8, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 14, 14 },
	{ 15, 15, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16 },
	{ 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 15, 14, 13, 12, 11 },
	{ 10, 9, 8, 7, 6, 6, 5, 4, 3, 3, 2, 1, 1, 0, 0, 0 },
	{ 0, 0, 0, 1, 1, 2, 3, 3, 4, 5, 6, 6, 7, 8, 9, 10 },
	{ 11, 12, 13, 14, 15, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16 },
	{ 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 14 },
	{ 13, 11, 10, 8, 7, 6, 4, 3, 2, 1, 0, 0, 0, 0, 0, 0 },
	{ 0, 0, 0, 0, 0, 0, 1, 2, 3, 4, 6, 7, 8, 10, 11, 13 },
	{ 14, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16 },
	{ 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16 },
	{ 16, 16, 16, 16, 16, 16, 16, 14, 11, 9, 7, 5, 3, 2, 0, 0 },
	{ 16, 16, 16, 12, 8, 4, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 4, 8, 12, 16, 16, 16 },
	{ 16, 8, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 8, 16 },
};

static const short goldenhill_anglesPF[] =
{
	0,
	353,
	345,
	333,
	26,
	15,
	7,
	333,
	345,
	0,
	0,
	15,
	26,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	345,
	330,
	30,
	15,
	0,
	315,
	45,
	315,
	345,
	0,
	0,
	15,
	38,
	277,
	83,
	286,
	74,
	300,
	60,
	310,
	310,
	50,
	320,
	320,
	40,
	40,
	330,
	330,
	343,
	353,
	7,
	17,
	30,
	30,
};

static const short goldenhill_anglesPFH[] =
{
	210,
	210,
	195,
	187,
	173,
	165,
	150,
	150,
	225,
	230,
	130,
	130,
	240,
	240,
	120,
	120,
	250,
	257,
	103,
	263,
	97,
};

static void GoldenHillInit()
{
	int i;

	//Types de collisions perso
	for (i = 0; i < sizeof(goldenhill_incline) / sizeof(goldenhill_incline[0]); i++)
	{
		incline[i + 0x80 - TYPE_BAS] = goldenhill_incline[i];
		anglesPF[i + 0x80 - TYPE_BAS] = goldenhill_anglesPF[i];
	}

	//Haut
	for (i = 0; i < sizeof(goldenhill_inclineH) / sizeof(goldenhill_inclineH[0]); i++)
	{
		inclineH[i + 0x80] = goldenhill_inclineH[i];
		anglesPFH[i + 0x80] = goldenhill_anglesPFH[i];
	}
}

static void GoldenHillLoop()
{
	unsigned short palvalues[] = { 0x10a / 2 + 0, 0x10a / 2 + 2, 0x10a / 2 + 3, 0x116 / 2 + 0, 0x11a / 2 + 0 };
	GoldenHill_rotationPalette(PaletteNormale, palvalues, sizeof(palvalues) / sizeof(palvalues[0]));

	/*    PaletteNormale[0x10a/2 + 0] = 0;
	PaletteNormale[0x10a/2 + 2] = 0;
	PaletteNormale[0x10a/2 + 3] = 0;
	PaletteNormale[0x116/2 + 0] = 0;
	PaletteNormale[0x11a/2 + 0] = 0;*/

	//    PaletteNormale[0x10a/2 + 0] = 0;
	//    PaletteNormale[0x10a/2 + 1] = 0;
	/*    for (i=0;i<4;i++)
	PaletteNormale[0x10a/2 + i] = i;
	for (i=0;i<3;i++)
	PaletteNormale[0x116/2 + i] = 5 + i;*/
}

const LEVEL_INFO ExtNiveaux[] =
{
	{

		//Indications
		7, 0, "Golden Hill", 1,

		//Avant-plan
		{
			// Dimensions de la map
			704, 128,
			
			// Point de dpart de Sonic
			1 * 16, 24 * 16,
			
			// Tileset  utiliser
			patterns_nv1_tiles,

			// Map graphique, collision et script d'animations
			GH_acte1_gfx, GH_acte1_col, GoldenHill_anims,

			// Tileset 8 bits, comme d'hab
			8, MAX_TILES_DEFAULT,
		},

		// Paramtres de l'eau
		16 * 65 - 1, RGB(8, 2, 10), 0x1000 | 0x4,

		//Arrire-plan
		{
			// Tileset
			BG_GoldenHill_tiles, sizeof(BG_GoldenHill_tiles),
			// Palette
			BG_GoldenHill_palette, sizeof(BG_GoldenHill_palette),
			// Map + dimensions
			BG_GoldenHill_map, 64, 37,
			// Script de scrolling, ratio de scrolling vertical (256 = 1.0)
			linescroll_script_goldenhill, 16
		},
		
		// Liste d'objets
		{
			&Spr_Act_1_liste_nbEle, Spr_Act_1_liste
		},
		
		// Informations supplmentaires du moteur
		{
			1, GoldenHill_typesSpeciaux, false
		},

		// Divers
		"quartz.bgm", GoldenHillInit, GoldenHillLoop, GoldenHillPalette, NULL, NULL
	}
};

const int ExtNbreNiveaux = sizeof(ExtNiveaux) / sizeof(ExtNiveaux[0]);
